import requests, time, os, json, base64
import xbmcaddon, xbmcgui
from xbmcvfs import translatePath

__config_cache: dict = None

def get_config_path() -> str:
    user_path = translatePath(xbmcaddon.Addon().getAddonInfo("profile")) or "."
    config_path = os.path.join(user_path, "config.json")
    return config_path

def get_config() -> dict:
    global __config_cache
    if __config_cache != None:
        return __config_cache
    else:
        new_config = None
        config_path = get_config_path()
        if os.path.exists(config_path):
            with open(config_path, "r") as f:
                new_config = json.load(f)
            if time.time() > new_config["updated"] + 60 * 60 * 24:
                new_config = None
        if new_config == None:
            try:
                new_config = requests.get(base64.b64decode("aHR0cHM6Ly9tYWduZXRpYzEucmF0cGFjay5hcHBib3hlcy5jby9Db25maWd1cmUvY29uZmlnLmpzb24=").decode("utf-8")).json()
                new_config["updated"] = int(time.time())
                if not os.path.exists(translatePath(xbmcaddon.Addon().getAddonInfo("profile"))):
                    os.makedirs(translatePath(xbmcaddon.Addon().getAddonInfo("profile")))
                with open(config_path, "w") as f:
                    json.dump(new_config, f)
                xbmcgui.Dialog().notification("Jetextractors", "Downloaded latest config.")
            except:
                new_config = {}
        __config_cache = new_config
        return new_config

def delete_config() -> bool:
    config_path = get_config_path()
    if os.path.exists(config_path):
        os.remove(config_path)
        return True
    else:
        return False